
{% extends 'base.html' %}

{% block title %}
    List
{% endblock title %}

{% block content %}
    <h1>Employee List</h1>
    
    <!-- <a href="{% url 'employee_create' %}" class="btn btn-primary">Create</a> -->

    <form method="post" id="form1" novalidate>
        {% csrf_token %}
        <div class="mb-3">
            <label for="name" class="form-label">Name</label>
            <input type="text" class="form-control" id="name"  name="name" >  
            <div id="nameError" class="form-text" style="display:none;color:red;"></div>
        </div>
        <div class="mb-3">
            <label for="age" class="form-label">Age</label>
            <input type="text" class="form-control" id="age"  name="age"  > 
            <div id="ageError" class="form-text" style="display:none;color:red;"></div>
        </div>
        <div class="mb-3"> 
            <input type="submit" class="btn btn-success"> 
        </div>
    </form> 

    <table class="table">
        <thead>
            <th>Name</th> 
            <th>Age</th> 
            <th></th>
        </thead>

        <tbody id="tbody-id">
            {% for emp in employees %}
                <tr id="tr-{{emp.id}}" >
                    <td>{{emp.name}}</td> 
                    <td>{{emp.age}}</td> 
                    <td>
                        <button data-pk="{{emp.id}}" class="btn btn-info  btn-edit">Edit</button>
                        <button data-pk="{{emp.id}}"  class="btn btn-danger btn-del">Delete</button>
                    </td> 
                </tr>
            {% endfor %}
        </tbody>
    </table>

    <div class="modal" tabindex="-1" role="dialog" id="employee-modal-id">
        <div class="modal-dialog" role="document">
        <div class="modal-content">

        </div>
        </div>
    </div>

<script>
    
    $('#form1').on('submit', (e) => {
        e.preventDefault();
        let formData = new FormData(e.target);

        // for(var pair of formData.entries()) {
        //     console.log(pair[0]+ ', '+ pair[1]);
        // }

        $.ajax({
            method: 'POST',
            url:'{% url "employee_create" %}',
            data: formData,
            processData: false,
            contentType: false,

            success: function(resp){

                if(resp.status == 200){
                    console.log(resp);
                    // console.log(resp.instance)
                    // console.log(typeof resp.instance) 

                    let instance = JSON.parse(resp.instance);
                    // console.log(instance[0].fields.name);
                    // console.log(instance[0].fields.age);
                    // console.log(instance[0].pk)
                    
                    let r= `<tr>
                                <td>${instance[0].fields.name}</td> 
                                <td>${instance[0].fields.age}</td> 
                                <td>
                                    <button data-pk=${instance[0].pk} class="btn btn-info  btn-edit">Edit</button>
                                    <button data-pk=${instance[0].pk}  class="btn btn-danger btn-del">Delete</button>
                                </td>
                            </tr>`; 

                    $('#tbody-id').append(r); 
                    $("#form1")[0].reset();
                    // or
                    // $("#formId").get(0).reset();

                }else if(resp.status == 400){
                    for(let error of resp.errors){ 
                        let el = $('#'+error[0]+'Error');  
                        el.css('display', 'block');
                        el.text(error[1]);

                        setTimeout(() => {
                            el.css('display', 'none');
                        }, 3000);
                    }
                }
            },
            error: function(err){
                console.log(err);
            }
        });
    })

    $("tbody").on("click", ".btn-del", function(e) { 
        e.preventDefault(); 

        // const id = $(this).attr("data-pk");
        const id = $(this).data("pk");      
        const delUrl = "{% url 'employee_delete' 11 %}".replace(11, id);

        let mythis = this;
        $.ajax({
            url: delUrl,
            method: 'POST',
            data: {
                csrfmiddlewaretoken: "{{ csrf_token }}"
            },
            success: function(resp){  
                if(resp.status == 200){ 
                    $(mythis).closest('tr').remove();
                }else{ 
                    alert(resp['error']);
                } 
            }, 
            error: function(err){
                alert(err);
            }
        })  
    });

    $('tbody').on('click', '.btn-edit', function(e){
        e.preventDefault();
        console.log('edit');

        const pk = $(this).attr('data-pk');
        const editUrl = "{% url 'employee_edit' 11 %}".replace(11, pk);
        
        $.ajax({
            url: editUrl,
            method: 'GET',
            success: function(data){
                if( data.status == 200){
                    let instance = JSON.parse(data.instance)
                    console.log(instance[0].fields)
            
                    let d = `
                    <div class="modal-header">
                        <h5 class="modal-title">Update Employee</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                        </button>
                    </div>

                    <form method="post" id="employeeUpdateForm" data-pk="${pk}">
                        {% csrf_token %}

                        <div class="modal-body">
                            <div class="mb-3">
                                <label for="name" class="form-label">Name</label>
                                <input type="text" class="form-control" id="name"  name="name" value="${instance[0].fields.name}" >  
                                <div id="nameError" class="form-text" style="display:none;color:red;"></div>
                            </div>
                            <div class="mb-3">
                                <label for="age" class="form-label">Age</label>
                                <input type="text" class="form-control" id="age"  name="age" value="${instance[0].fields.age}"  > 
                                <div id="ageError" class="form-text" style="display:none;color:red;"></div>
                            </div>
                        </div>

                        <div class="modal-footer">  
                            <input type="submit" class="btn btn-success" value="Update">  
                        </div>
                    </form> 
                    `;
                    // $('#employee-modal-id').css('display', 'block');
                    $('#employee-modal-id').show();
                    $('#employee-modal-id .modal-content').empty().append(d);
                    
                }else{  
                    console.log(data.errors)
                }
            },
            error: function(err){
                console.log(err);
            }
        })
    })

    $("#employee-modal-id").on('click', '.close', function(e){
        console.log($(this));
        $(this).closest('div.modal').hide();
    })

    $('body').on('submit', '#employeeUpdateForm', (e) => {
        e.preventDefault();
        let formData = new FormData(e.target);
        const pk = e.target.getAttribute('data-pk');
        const updateUrl = "{% url 'employee_edit' 11 %}".replace(11, pk);

        $.ajax({
            method: 'POST',
            url: updateUrl,
            data: formData,
            processData: false,
            contentType: false,

            success: function(resp){
                if(resp.status == 200){
                    let instance = JSON.parse(resp.instance); 
                    let r = `   <td>${instance[0].fields.name}</td> 
                                <td>${instance[0].fields.age}</td> 
                                <td>
                                    <button data-pk=${instance[0].pk} class="btn btn-info  btn-edit">Edit</button>
                                    <button data-pk=${instance[0].pk}  class="btn btn-danger btn-del">Delete</button>
                                </td> 
                            `;
                    $("#tr-"+instance[0].pk).empty().append(r);
                    $("#employee-modal-id").hide();
                }else{
                    for(let err of resp.errors ){ 
                        let el = $('#employee-modal-id #'+err[0]+'Error');
                        el.text(err[1]);
                        el.css('display', 'block');
                        setTimeout(() => {
                            el.css('display', 'none');
                        }, 1000);
                    }
                }
            },
            error: function(err){
                console.log(err);
            }
        })
    })
    
</script>

{% endblock content %}